#include <stdio.h>

/*
  Implement sum() to seperately sum the
  odd and even numbers in an array of integers,
  and then return the product.

    - using `goto` and labels
    - without using `for`, `while`, or `do`
    - with only one-armed `if`s
    - with only `goto` in the "then" part of `if`
*/

int sum(int *a, int len)
{
  int i = 0;
  int sum = 0;
  int sumEvens = 0;

 count:
  if(i >= len)
    goto done;
  
  //check for odd or even
  // check lowest bit by doing & with 1
  if((a[i] & 1) == 1) // odd
    goto addOddNum;    
 
 addEvens:
  sumEvens += a[i];
    

    // if result is 1 then it's an odd, else even     
  i++;
  goto count;

 addOddNum:
      sum+= a[i];
      i++;
      goto count;

  /* for(i= 0; i < len; i++)
    {
      sum+= a[i];
    }
  */
 done:
  
  return sum * sumEvens;
}

int a[] = {1, 2, 5, 7, 4, 6, 8, 0, 11};

int main()
{
  int v = sum(a, sizeof(a) / sizeof(int));

  printf("%d\n", v);

  return 0;
}
